/*
## Creator
👨‍💻 Created by ©AjayMc

🎥 YouTube: [AjayMc Channel](https://youtube.com/@ajaytamfan)  
🔧 Discord: [Ajay Comunity](https://discord.com/invite/NNWf2CxtEY)  
🌐 Website: [Ajay Studio](http://www.ajaystudio.xyz)

█▀▄ █▀▀ ▄▀█ ▀█▀ █░█   █▄▄ ▄▀█ █▄░█  
█▄▀ ██▄ █▀█ ░█░ █▀█   █▄█ █▀█ █░▀█
*/




//Please read readme.md to see the time format used and examples
const BAN_TIME_STRING = '5m 30s'; // edit tire times here, warning! don't change anything except this













import { world } from "@minecraft/server";
import { MessageFormData } from "@minecraft/server-ui";

const DEATHBAN_TAG_PREFIX = "deathban:";

function parseBanTime(timeString) {
    const regex = /(\d+)([smhd])/;
    const matches = timeString.match(regex);
    if (!matches) return 0;

    const amount = parseInt(matches[1]);
    const unit = matches[2];

    switch (unit) {
        case 's':
            return amount;
        case 'm':
            return amount * 60;
        case 'h':
            return amount * 60 * 60;
        case 'd':
            return amount * 60 * 60 * 24;
        default:
            return 0;
    }
}

function formatRemainingTime(remainingSeconds) {
    const days = Math.floor(remainingSeconds / (60 * 60 * 24));
    remainingSeconds %= 60 * 60 * 24;
    const hours = Math.floor(remainingSeconds / (60 * 60));
    remainingSeconds %= 60 * 60;
    const minutes = Math.floor(remainingSeconds / 60);
    const seconds = remainingSeconds % 60;

    let formattedTime = '';
    if (days > 0) formattedTime += `${days} day${days > 1 ? 's' : ''} `;
    if (hours > 0) formattedTime += `${hours} hour${hours > 1 ? 's' : ''} `;
    if (minutes > 0) formattedTime += `${minutes} minute${minutes > 1 ? 's' : ''} `;
    formattedTime += `${seconds} second${seconds !== 1 ? 's' : ''}`;

    return formattedTime.trim();
}

const BAN_TIME_SECONDS = parseBanTime(BAN_TIME_STRING);

async function ForceOpen(player, form) {
    while (true) {
        try {
            const response = await form.show(player);
            if (!response.canceled && response.cancelationReason !== "UserBusy") return response;
        } catch (error) {
            player.sendMessage(`Error displaying form: ${error}`);
        }
    }
}

async function showBanForm(player) {
    const currentTime = Date.now();
    const banTag = player.getTags().find(tag => tag.startsWith(DEATHBAN_TAG_PREFIX));
    let remainingTime = banTag ? Math.max(0, Math.floor((parseInt(banTag.slice(DEATHBAN_TAG_PREFIX.length), 10) - currentTime) / 1000)) : 0;
   ["slowness", "blindness", "resistance"].forEach(effect => player.addEffect(effect, 9999, { amplifier: 255, showParticles: false }));
   
    const displayBanForm = async () => {
        const remainingTimeFormatted = formatRemainingTime(remainingTime);

        const form = new MessageFormData()
            .title("Ban Notification")
            .body(`You have been banned for §cdying.\n§rPlease wait §c${remainingTimeFormatted}.§r`)
            .button1("Exit")
            .button2("Try Again");

        const response = await ForceOpen(player, form);

        if (response.selection === 1) {
            if (response.canceled || remainingTime > 0) {
                remainingTime = banTag ? Math.max(0, Math.floor((parseInt(banTag.slice(DEATHBAN_TAG_PREFIX.length), 10) - Date.now()) / 1000)) : 0;
                if (remainingTime >= 0) displayBanForm(); player.runCommand(`playsound random.break @s`)
            } else {
                await player.runCommandAsync(`effect @s clear`);
                player.getTags().filter(tag => tag.startsWith(DEATHBAN_TAG_PREFIX)).forEach(tag => player.removeTag(tag));
                player.runCommand(`playsound random.toast @s`)
            }
        } else if (response.selection === 0) {
        	showBanForm(player);
            player.runCommandAsync(`kick "${player.name}"`);
        }
    };

    await displayBanForm();
}

world.afterEvents.entityDie.subscribe(({ deadEntity }) => {
    if (deadEntity.typeId === "minecraft:player") {
        const player = deadEntity;
        const currentTime = Date.now();
        const banTag = player.getTags().find(tag => tag.startsWith(DEATHBAN_TAG_PREFIX));

        if (!banTag || parseInt(banTag.slice(DEATHBAN_TAG_PREFIX.length), 10) <= currentTime) {
            const banEndTime = currentTime + BAN_TIME_SECONDS * 1000;
            player.addTag(`${DEATHBAN_TAG_PREFIX}${banEndTime}`);
        }
    }
});

world.afterEvents.playerSpawn.subscribe(({ player }) => {
    if (player.getTags().some(tag => tag.startsWith(DEATHBAN_TAG_PREFIX))) {
        showBanForm(player);
    }
});
